<?php
namespace Setforms2\Shared\ORM;

use Doctrine\DBAL\Platforms\AbstractPlatform;
use Doctrine\DBAL\Types\ConversionException;

class DateType extends \Doctrine\DBAL\Types\DateType
{
    public function convertToPHPValue($value, AbstractPlatform $platform)
    {
        if ($value === null || $value instanceof DateTime) {
            return $value;
        }

        $formatString = $platform->getDateFormatString();
        $val = DateTime::createFromFormat($formatString, $value);
        if ( ! $val) {
            throw ConversionException::conversionFailedFormat($value, $this->getName(), $formatString);
        }
        return $val;
    }
}

