<?php
namespace Fiscal\Logic\Sped;

use Geral\Util\TratamentoDeMensagens;
use \Setforms2\Runtime\Helper\Procedure;
use \Setforms2\Runtime\Helper\Procedure\Param;
use \Fiscal\Entities\Paramdeclaces;

class SpedContribuicoes{

    public static function ExportSped($cdempresa, $nrorg, $nmarquivo, $cdlivromag, $dtrefini, $dtreffim, $livromag, $indEscritu, $tpnatjurpj){
        try {
            if ($cdempresa == null){
                tk_abort('Empresa deve ser informada.');
            }
            elseif ($cdlivromag == null){
                tk_abort('Livro Magnético deve ser informado.');
            }
            elseif ($dtrefini == null){
                tk_abort('Data Inicial deve ser informada.');
            }
            elseif ($dtreffim == null){
                tk_abort('Data Final deve ser informada.');
            }
            elseif ($dtrefini > $dtrefini){
                tk_abort('Data final deve ser maior que data inicial.');
            }
            else{
                /** @var $Paramdeclaces \Fiscal\Entities\Paramdeclaces */
                $Paramdeclaces = \Fiscal\Entities\Paramdeclaces::findOneByCdempresaAndNrorgAndCdtelaAndCdinscricao($cdempresa, $nrorg,'FIS95000','FEDERAL');

              //  TK_VAR_DUMP($Paramdeclaces->getCdcampo1());
                if ($Paramdeclaces == null){
                    self::insert_paramdeclaces($cdempresa,$nrorg);
                    tk_open_window('win_pbi00137_000_01');
        //            tk_new_row('win_pbi00137_000_01','win_pbi00137_000_01');

                }
                elseif ($Paramdeclaces->getCdcampo1() == null) {
                    tk_open_window('win_pbi00137_000_01');
                }
                else{
                    if ($nmarquivo == null){
                        tk_abort('Nome do arquivo deve ser informado.');
                    }
                    else{
                        /** @var $nrseqarqmag \Fiscal\Repositories\Arqmagpiscofins */
                        $nrseqarqmag = \Fiscal\Repositories\Arqmagpiscofins::MaiorCod($nrorg);
                        $nrseqarqmag += 1;

                        $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
                        $connection->beginTransaction();

                        for ($i=0; $i < 1; $i++){
                        $procedure = new Procedure('ARQUIVO_PIS_COFINS');
                        $procedure->addParam(new Param('P_CDLIVROMAG', Param::PARAM_INPUT, $cdlivromag, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDEMPRESA', Param::PARAM_INPUT, $cdempresa, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTINICIAL', Param::PARAM_INPUT, $dtrefini, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_DTFINAL', Param::PARAM_INPUT, $dtreffim, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_LIVROMAG', Param::PARAM_INPUT, $livromag, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_NRSEQARQMAG', Param::PARAM_INPUT, $nrseqarqmag, Param::PARAM_TYPE_STR)); /*P_NRSEQARQMAG  select+1*/
                        $procedure->addParam(new Param('P_VERSAO', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo8(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_INDESCRITU', Param::PARAM_INPUT, $indEscritu, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_IDSITUESP', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo2(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_NUMRECANT', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo3(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_ATIVIDADE', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo4(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDINCTRIB', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo5(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_INDAPROCRED', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo6(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CDTPCON', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo7(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_CRTESCRITUR', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo10(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_TPESCRITU', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo1(), Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_TPNATJURPJ', Param::PARAM_INPUT, $tpnatjurpj, Param::PARAM_TYPE_STR));
                        $procedure->addParam(new Param('P_GERABCLP', Param::PARAM_INPUT, $Paramdeclaces->getCdcampo9(), Param::PARAM_TYPE_STR));
                        $procedure->call();
                        }
                        if ($i==0){
                            $connection->rollBack();
                        }
                        elseif ($i==1){
                            $connection->commit();
                        }
                    }
                }
            }
        } catch (\Exception $e) {
            throw $e;
        }
    }

    /*-------Comentário da Função geraArquivo()-------
    fopen abre o arquivo no modo de escrita, depois cria-se uma conexão com o banco,
    executa-se a busca na tabela 'temporaria' onde estão as informações e o foreach serve para
    percorrer todas as linhas na qual o select retorna e montar o arquivo txt.
    Após o foreach fecha-se e salva o arquivo com o fclose.
    Por fim limpa-se a tabela 'temporaria'.*/
    public static function geraArquivo($nrorg){
        try {
           $nmarquivo = tk_get_field_value('NMARQUIVO');
           /** @var $nrseqarqmag \Fiscal\Repositories\Arqmagpiscofins */
           $nrseqarqmag = \Fiscal\Repositories\Arqmagpiscofins::MaiorCod($nrorg);

           $caminho = APP_PATH . "/public/Fiscal/$nrorg/";
            if (!is_dir($caminho)){
               mkdir($caminho, "0777", true);
           }

           $file = fopen("$caminho$nmarquivo.txt", "w");

           $connection = \Setforms2\Shared\Registry::getEntityManagerConnection();
           $stmt = $connection->prepare("SELECT T.DSREGARQMAG
                                           FROM
                                               (SELECT DSREGARQMAG, ROWNUM AS SEQUENCIAL
                                                  FROM
                                                      (SELECT NRORDREGARQMAG,DSREGARQMAG
                                                         FROM ARQMAGPISCOFINS
                                                        WHERE NRSEQARQMAG = '$nrseqarqmag'
                                                          AND NRORG = '$nrorg'
                                                        ORDER BY NRORDREGARQMAG))T
                                        ");
           $stmt->execute();
           $value = $stmt->fetchAll(\PDO::FETCH_ASSOC);
           foreach ($value as $linha) {
               fprintf($file, "%s", iconv('UTF-8', "ASCII//TRANSLIT", $linha['DSREGARQMAG']."\r\n")); //iconv serve para converter o arquivo txt para a codificação ANSI
           }
           fclose($file);
           $url = realpath($caminho . $nmarquivo . '.txt');

           $arquivo = new \TkFile($url);
           $arquivo->download();

           tk_message('Operação realizada com sucesso!', 'success');
           \Fiscal\Repositories\Arqmagpiscofins::LimpaTabela($nrorg,$nrseqarqmag);

        } catch (\Exception $e) {
            throw $e;
        }


    }

    public static function AtiDesAction($cdempresa, $nrorg){


        /** @var $Paramdeclaces \Fiscal\Entities\Paramdeclaces */
        // $Paramdeclaces = \Fiscal\Entities\Paramdeclaces::findOneByCdempresaAndNrorg($cdempresa, $nrorg);
        $campo5 = tk_get_field_value('CDCAMPO5');

        if ($campo5 != null){

         //    tk_set_disable_action('TK_NEW_ROW_U');
         //    tk_set_disable_action('TK_DELETE_ROW_U');
         //     tk_set_disable_action('TK_CANCEL');

           if ($campo5 != 2){
               tk_disable_field('CDCAMPO10', 'tab_pbi00137_000_ParametrosSpedContribuicoes', 'win_pbi00137_000_01');
           } else {
               tk_enable_field('CDCAMPO10', 'tab_pbi00137_000_ParametrosSpedContribuicoes', 'win_pbi00137_000_01');
               tk_set_field_required('CDCAMPO10','tab_pbi00137_000_ParametrosSpedContribuicoes', 'win_pbi00137_000_01');
           }
        }
    }

    public static function insert_paramdeclaces($cdempresa,$nrorg){
        try {
            $data = \Geral\Util\DateUtil::getDataAtual();
//            $cdtela = \Geral\Util\NovoCodigo::geraCodigo(\Geral\Util\Ambiente::getNrorg(),'CDTELA',1,10);
            $cdoperador = \Geral\Util\Ambiente::getCdOperador();
            $paramdeclaces = new Paramdeclaces();
            $paramdeclaces->setCdtela('FIS95000');
            $paramdeclaces->setCdempresa($cdempresa);
            $paramdeclaces->setCdinscricao('FEDERAL');
            $paramdeclaces->setNrorg($nrorg);
            $paramdeclaces->setDtinclusao($data);
            $paramdeclaces->setDtultatu($data);
            $paramdeclaces->setCdoperinclusao($cdoperador);
            $paramdeclaces->setCdoperultatu($cdoperador);
            $paramdeclaces->persist(); //pre commit
            \Setforms2\Shared\Registry::getEntityManager()->flush(); //Commit
        } catch (\Exception $e) {
            throw $e;
        }

    }

}